# docker build . -f dockerfiles/Dockerfile.iceoryx -t performance_test_iceoryx
# docker run -it --shm-size 2G performance_test_iceoryx bash
# ros2 run performance_test perf_test -c iceoryx --msg Array1k --print-to-console

ARG BASE_IMAGE=osrf/ros:rolling-desktop
FROM $BASE_IMAGE

ARG ROS_DISTRO=rolling
ARG ICEORYX_VERSION=5fe215eab267b0ad68bc5552aecd4b6e728e4c99

SHELL ["/bin/bash", "-c"]

RUN apt-get update && \
    apt-get install -y bison default-jdk libacl1-dev

RUN mkdir -p iceoryx_ws/src && \
    cd $_ && \
    git clone https://github.com/eclipse-iceoryx/iceoryx.git && \
    cd iceoryx && \
    git checkout $ICEORYX_VERSION && \
    cd ../.. && \
    colcon build \
      --install-base /opt/iceoryx \
      --cmake-args \
        -DIOX_MAX_PUBLISHERS=32 \
        -DIOX_MAX_SUBSCRIBERS=32

ADD . /perf_test_ws/src/performance_test

RUN source /opt/ros/$ROS_DISTRO/setup.bash && \
    source /opt/iceoryx/setup.bash && \
    cd /perf_test_ws && \
    colcon build \
      --install-base /opt/performance_test \
      --merge-install \
      --cmake-clean-cache \
      --cmake-args \
        -DCMAKE_BUILD_TYPE=Release \
        -DPERFORMANCE_TEST_ICEORYX_ENABLED=ON

RUN echo "source /opt/ros/$ROS_DISTRO/setup.bash" >> /root/setup.bash
RUN echo "source /opt/performance_test/setup.bash" >> /root/setup.bash

ADD dockerfiles/roudi_config.toml /etc/iceoryx/roudi_config.toml
RUN echo "iox-roudi -c /etc/iceoryx/roudi_config.toml &" >> /root/setup.bash

RUN echo "source /root/setup.bash" >> /root/.bashrc

# Install dependencies for running performance_report
RUN apt-get update && \
    apt-get install -y python3-pip && \
    python3 -m pip install -U bokeh selenium pandas 
